## ggml 0.9.4.185

=== debian/changelog ===
ggml (0.9.4.185-1) unstable; urgency=medium

  * Upstream llama.cpp and whisper.cpp syncs
  * Move backends to Debian location
  * Build natively for Raspberry Pi5 on Ubuntu ARM

 -- Mathieu Baudier <mbaudier@argeo.org>  Tue, 11 Nov 2025 07:55:58 +0000
